Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/HeuristicLab.Algorithms.PushGP.Cli.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/HeuristicLab.Algorithms.PushGP.Cli.csproj	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/HeuristicLab.Algorithms.PushGP.Cli.csproj	(revision 14328)
@@ -10,7 +10,8 @@
     <RootNamespace>HeuristicLab.Algorithms.PushGP.Cli</RootNamespace>
     <AssemblyName>HeuristicLab.Algorithms.PushGP.Cli</AssemblyName>
-    <TargetFrameworkVersion>v4.5.2</TargetFrameworkVersion>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
     <AutoGenerateBindingRedirects>true</AutoGenerateBindingRedirects>
+    <TargetFrameworkProfile />
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
@@ -32,4 +33,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <LangVersion>5</LangVersion>
   </PropertyGroup>
   <ItemGroup>
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/Program.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/Program.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/Program.cs	(revision 14328)
@@ -12,6 +12,6 @@
         static void Main(string[] args)
         {
-            //Stepwise().Wait();
-            PerformanceTest();
+            Stepwise().Wait();
+            //PerformanceTestInterpreter();
             //PerformanceTestCodeGenerator();
 
@@ -22,9 +22,11 @@
         static async Task Stepwise()
         {
-            var program = PushGPInterpreter.Encode("( 2 3 INTEGER.* 4.1 5.2 FLOAT.+ TRUE FALSE BOOLEAN.OR )");
+            var program = PushGPInterpreter.Encode(@"( CODE.QUOTE ( INTEGER.POP 1 )
+                                                       CODE.QUOTE ( CODE.DUP INTEGER.DUP 1 INTEGER.- CODE.DO INTEGER.* )
+                                                       INTEGER.DUP 2 INTEGER.< CODE.IF )");
             var interpreter = new PushGPInterpreter();
 
-            var task = interpreter.InterpreteAsync(program);
-            await interpreter.PauseAsync();
+            interpreter.IntegerStack.Push(5);
+            interpreter.InterpretAsync(program, true).Wait();
 
             while (!interpreter.IsCompleted)
@@ -49,5 +51,5 @@
         }
 
-        static void PerformanceTest()
+        static void PerformanceTestInterpreter()
         {
             var program = PushGPInterpreter.Encode("( 5 INTEGER.DUP INTEGER.+ )");
@@ -58,6 +60,6 @@
             for (var i = 0; i < 20000000; i++)
             {
-                interpreter.Interprete(program);
-                interpreter.Reset();
+                interpreter.Interpret(program);
+                interpreter.Clear();
             }
             sw.Stop();
@@ -71,9 +73,8 @@
 
             sw.Start();
-            var expressions = CodeGenerator.RandomCode(10000000);
+            var expressions = CodeGenerator.RandomCode(3000000);
             sw.Stop();
 
-            Console.WriteLine($"Count: {expressions.Count()}");
-            Console.WriteLine(sw.Elapsed);
+            Console.WriteLine(string.Format("Generated {0} in {1}", expressions.Count(), sw.Elapsed));
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Exporter/Exporter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Exporter/Exporter.cs	(revision 14328)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Exporter/Exporter.cs	(revision 14328)
@@ -0,0 +1,12 @@
+﻿using HeuristicLab.Algorithms.PushGP.Expressions;
+
+namespace HeuristicLab.Algorithms.PushGP.Exporter
+{
+    public static class Exporter
+    {
+        public static string ToString(Expression expression)
+        {
+            return expression.ToString();
+        }
+    }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Boolean/BooleanPushExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Boolean/BooleanPushExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Boolean/BooleanPushExpression.cs	(revision 14328)
@@ -1,23 +1,29 @@
-﻿using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Boolean
 {
     public class BooleanPushExpression : Expression
     {
-        public BooleanPushExpression(bool value) : base(OpCode.BooleanPush)
+        private readonly bool value;
+        public BooleanPushExpression(bool value)
         {
-            this.Value = value;
+            this.value = value;
         }
 
-        public bool Value { get; }
+        public override bool IsCodeOp { get { return false; } }
 
-        public override void Eval(IInterpreterService interpreterService)
+        public override void Eval(IInterpreter interpreter)
         {
-            interpreterService.BooleanStack.Push(Value);
+            interpreter.BooleanStack.Push(this.value);
         }
 
         public override string ToString()
         {
-            return $"{this.Value.ToString().ToUpper()}";
+            return this.value.ToString().ToUpper();
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeDefineExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeDefineExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeDefineExpression.cs	(revision 14328)
@@ -1,21 +1,36 @@
-﻿using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using HeuristicLab.Algorithms.PushGP.Expressions.Exec;
+using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Code
 {
     public class CodeDefineExpression : Expression
     {
-        public CodeDefineExpression() : base(OpCode.CodeDefine)
-        { }
+        public override bool IsCodeOp { get { return true; } }
 
-        public override void Eval(IInterpreterService interpreterService)
+        public override void Eval(IInterpreter interpreter)
         {
-            Define(
-                interpreterService.CodeStack,
-                interpreterService.NameStack,
-                interpreterService.CustomExpressions,
-                value => new ExecPushExpression(value));
+            // not enough arguments on stack
+            if (interpreter.NameStack.Count == 0 ||
+                interpreter.CodeStack.Count == 0)
+                return;
 
-            // as the interpreter does not pop code expressions
-            interpreterService.CodeStack.Pop();
+            var name = interpreter.NameStack.Pop();
+            var expression = new ExecPushExpression(interpreter.CodeStack.Top);
+
+            if (interpreter.CustomExpressions.ContainsKey(name))
+            {
+                interpreter.CustomExpressions[name] = expression;
+            }
+            else
+            {
+                interpreter.CustomExpressions.Add(name, expression);
+            }
+
+            interpreter.CodeStack.Pop();
+        }
+
+        public override string ToString()
+        {
+            return Symbols.CodeDefine;
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeDoExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeDoExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeDoExpression.cs	(revision 14328)
@@ -1,19 +1,23 @@
-﻿using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Code
 {
     public class CodeDoExpression : Expression
     {
-        public CodeDoExpression() : base(OpCode.CodeDo)
-        { }
+        public override bool IsCodeOp { get { return true; } }
 
-        public override void Eval(IInterpreterService interpreterService)
+        public override void Eval(IInterpreter interpreter)
         {
             // not enough arguments on stack
-            if (interpreterService.CodeStack.Count == 0)
+            if (interpreter.CodeStack.Count == 0)
                 return;
 
-            var expression = interpreterService.CodeStack.Pop();
-            interpreterService.ExecStack.Push(expression);
+            var expression = interpreter.CodeStack.Pop();
+            interpreter.ExecStack.Push(expression);
+        }
+
+        public override string ToString()
+        {
+            return Symbols.CodeDo;
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeIfExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeIfExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeIfExpression.cs	(revision 14328)
@@ -1,26 +1,30 @@
-﻿using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Code
 {
     public class CodeIfExpression : Expression
     {
-        public CodeIfExpression() : base(OpCode.CodeIf)
-        { }
+        public override bool IsCodeOp { get { return true; } }
 
-        public override void Eval(IInterpreterService interpreterService)
+        public override void Eval(IInterpreter interpreter)
         {
             // not enough arguments on stack
-            if (interpreterService.BooleanStack.Count == 0 ||
-                interpreterService.CodeStack.Count < 2)
+            if (interpreter.BooleanStack.Count == 0 ||
+                interpreter.CodeStack.Count < 2)
                 return;
 
-            var condition = interpreterService.BooleanStack.Pop();
-            var expressionFalse = interpreterService.CodeStack.Pop();
-            var expressionTrue = interpreterService.CodeStack.Pop();
+            var condition = interpreter.BooleanStack.Pop();
+            var expressionFalse = interpreter.CodeStack.Pop();
+            var expressionTrue = interpreter.CodeStack.Pop();
 
-            interpreterService.ExecStack.Push(condition
+            interpreter.ExecStack.Push(condition
                 ? expressionTrue
                 : expressionFalse);
         }
+
+        public override string ToString()
+        {
+            return Symbols.CodeIf;
+        }
     }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeNoopExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeNoopExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeNoopExpression.cs	(revision 14328)
@@ -1,15 +1,13 @@
-﻿using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Code
 {
     public class CodeNoopExpression : Expression
     {
-        public CodeNoopExpression() : base(OpCode.CodeNoop)
+        public override bool IsCodeOp { get { return true; } }
+
+        public override void Eval(IInterpreter interpreter)
         {
-        }
-
-        public override void Eval(IInterpreterService interpreterService)
-        {
-            // nothing to do
+            // do nothing
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeQuoteExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeQuoteExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Code/CodeQuoteExpression.cs	(revision 14328)
@@ -1,19 +1,23 @@
-﻿using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Code
 {
     public class CodeQuoteExpression : Expression
     {
-        public CodeQuoteExpression() : base(OpCode.CodeQuote)
-        { }
+        public override bool IsCodeOp { get { return true; } }
 
-        public override void Eval(IInterpreterService interpreterService)
+        public override void Eval(IInterpreter interpreter)
         {
             // not enough arguments on stack
-            if (interpreterService.ExecStack.Count == 0)
+            if (interpreter.ExecStack.Count == 0)
                 return;
 
-            var expression = interpreterService.ExecStack.Pop();
-            interpreterService.CodeStack.Push(expression);
+            var expression = interpreter.ExecStack.Pop();
+            interpreter.CodeStack.Push(expression);
+        }
+
+        public override string ToString()
+        {
+            return Symbols.CodeQuote;
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecDefineExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecDefineExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecDefineExpression.cs	(revision 14328)
@@ -1,21 +1,36 @@
-﻿using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using HeuristicLab.Algorithms.PushGP.Expressions.Exec;
+using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Code
 {
     public class ExecDefineExpression : Expression
     {
-        public ExecDefineExpression() : base(OpCode.ExecDefine)
-        { }
+        public override bool IsCodeOp { get { return false; } }
 
-        public override void Eval(IInterpreterService interpreterService)
+        public override void Eval(IInterpreter interpreter)
         {
-            Define(
-                interpreterService.ExecStack,
-                interpreterService.NameStack,
-                interpreterService.CustomExpressions,
-                value => new ExecPushExpression(value));
+            // not enough arguments on stack
+            if (interpreter.NameStack.Count == 0 ||
+                interpreter.CodeStack.Count == 0)
+                return;
 
-            // as the interpreter does not pop code expressions
-            interpreterService.ExecStack.Pop();
+            var name = interpreter.NameStack.Pop();
+            var expression = new ExecPushExpression(interpreter.ExecStack.Top);
+
+            if (interpreter.CustomExpressions.ContainsKey(name))
+            {
+                interpreter.CustomExpressions[name] = expression;
+            }
+            else
+            {
+                interpreter.CustomExpressions.Add(name, expression);
+            }
+
+            interpreter.ExecStack.Pop();
+        }
+
+        public override string ToString()
+        {
+            return Symbols.CodeDefine;
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecDoRangeExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecDoRangeExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecDoRangeExpression.cs	(revision 14328)
@@ -1,26 +1,25 @@
-﻿using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Exec
 {
     public class ExecDoRangeExpression : Expression
     {
-        public ExecDoRangeExpression() : base(OpCode.ExecDoXRange)
-        { }
+        public override bool IsCodeOp { get { return false; } }
 
-        public override void Eval(IInterpreterService interpreterService)
+        public override void Eval(IInterpreter interpreter)
         {
             // not enough arguments on stack
-            if (interpreterService.IntegerStack.Count < 2 ||
-                interpreterService.ExecStack.Count == 0)
+            if (interpreter.IntegerStack.Count < 2 ||
+                interpreter.ExecStack.Count == 0)
                 return;
 
-            var destinationIndex = interpreterService.IntegerStack.Pop();
-            var currentIndex = interpreterService.IntegerStack.Pop();
-            var loopBody = interpreterService.ExecStack.Pop();
+            var destinationIndex = interpreter.IntegerStack.Pop();
+            var currentIndex = interpreter.IntegerStack.Pop();
+            var loopBody = interpreter.ExecStack.Pop();
 
             if (destinationIndex == currentIndex)
             {
-                interpreterService.IntegerStack.Push(currentIndex);
-                interpreterService.ExecStack.Push(loopBody);
+                interpreter.IntegerStack.Push(currentIndex);
+                interpreter.ExecStack.Push(loopBody);
             }
             else
@@ -30,13 +29,18 @@
                     : currentIndex + 1;
 
-                interpreterService.IntegerStack.Push(currentIndex);
-                interpreterService.IntegerStack.Push(nextIndex);
-                interpreterService.IntegerStack.Push(destinationIndex);
+                interpreter.IntegerStack.Push(currentIndex);
+                interpreter.IntegerStack.Push(nextIndex);
+                interpreter.IntegerStack.Push(destinationIndex);
 
                 var expression = new ExecDoRangeExpression();
-                interpreterService.ExecStack.Push(loopBody);
-                interpreterService.ExecStack.Push(loopBody);
-                interpreterService.ExecStack.Push(expression);
+                interpreter.ExecStack.Push(loopBody);
+                interpreter.ExecStack.Push(loopBody);
+                interpreter.ExecStack.Push(expression);
             }
+        }
+
+        public override string ToString()
+        {
+            return Symbols.ExecDoXRange;
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecExpandExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecExpandExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecExpandExpression.cs	(revision 14328)
@@ -1,27 +1,44 @@
-﻿using System.Linq;
-using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using System.Text;
+using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Exec
 {
     public class ExecExpandExpression : Expression
     {
-        public ExecExpandExpression(Expression[] expressions) : base(OpCode.ExecExpand)
+        private const string prefix = "( ";
+        private const string postifx = " )";
+        private const string delimiter = " ";
+
+        private readonly Expression[] expressions;
+        public ExecExpandExpression(Expression[] expressions)
         {
-            this.Expressions = expressions;
+            this.expressions = expressions;
         }
 
-        public Expression[] Expressions { get; }
+        public override bool IsCodeOp { get { return false; } }
 
-        public override void Eval(IInterpreterService interpreterService)
+        public override void Eval(IInterpreter interpreter)
         {
-            foreach (var expression in this.Expressions)
-            {
-                interpreterService.ExecStack.Add(expression);
-            }
+            interpreter.ExecStack.Push(this.expressions);
         }
 
         public override string ToString()
         {
-            return $"( {string.Join(" ", this.Expressions.Reverse())} )";
+            if (this.expressions.Length == 0)
+            {
+                return string.Empty;
+            }
+
+            var sb = new StringBuilder();
+            sb.Append(prefix);
+
+            for (var i = this.expressions.Length - 1; i > 0; i--)
+            {
+                sb.Append(this.expressions[i] + delimiter);
+            }
+
+            sb.Append(this.expressions[0] + postifx);
+
+            return sb.ToString();
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecIfExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecIfExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecIfExpression.cs	(revision 14328)
@@ -1,26 +1,30 @@
-﻿using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Exec
 {
     public class ExecIfExpression : Expression
     {
-        public ExecIfExpression() : base(OpCode.ExecIf)
-        { }
+        public override bool IsCodeOp { get { return false; } }
 
-        public override void Eval(IInterpreterService interpreterService)
+        public override void Eval(IInterpreter interpreter)
         {
             // not enough arguments on stack
-            if (interpreterService.BooleanStack.Count == 0 ||
-                interpreterService.ExecStack.Count < 2)
+            if (interpreter.BooleanStack.Count == 0 ||
+                interpreter.ExecStack.Count < 2)
                 return;
 
-            var condition = interpreterService.BooleanStack.Pop();
-            var expressionTrue = interpreterService.ExecStack.Pop();
-            var expressionFalse = interpreterService.ExecStack.Pop();
+            var condition = interpreter.BooleanStack.Pop();
+            var expressionTrue = interpreter.ExecStack.Pop();
+            var expressionFalse = interpreter.ExecStack.Pop();
 
-            interpreterService.ExecStack.Push(condition
+            interpreter.ExecStack.Push(condition
                 ? expressionTrue
                 : expressionFalse);
         }
+
+        public override string ToString()
+        {
+            return Symbols.ExecIf;
+        }
     }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecPushExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecPushExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecPushExpression.cs	(revision 14328)
@@ -1,23 +1,24 @@
-﻿using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Exec
 {
     public class ExecPushExpression : Expression
     {
-        public ExecPushExpression(Expression value) : base(OpCode.ExecPush)
+        private readonly Expression value;
+        public ExecPushExpression(Expression value)
         {
-            this.Value = value;
+            this.value = value;
         }
 
-        public Expression Value { get; }
+        public override bool IsCodeOp { get { return false; } }
 
-        public override void Eval(IInterpreterService interpreterService)
+        public override void Eval(IInterpreter interpreter)
         {
-            interpreterService.ExecStack.Push(Value);
+            interpreter.ExecStack.Push(this.value);
         }
 
         public override string ToString()
         {
-            return $"{base.ToString()}({this.Value})";
+            return this.value.ToString();
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecYExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecYExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Exec/ExecYExpression.cs	(revision 14328)
@@ -1,24 +1,28 @@
-﻿using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Exec
 {
     public class ExecYExpression : Expression
     {
-        public ExecYExpression() : base(OpCode.ExecY)
-        { }
+        public override bool IsCodeOp { get { return false; } }
 
-        public override void Eval(IInterpreterService interpreterService)
+        public override void Eval(IInterpreter interpreter)
         {
             // not enough arguments on stack
-            if (interpreterService.ExecStack.Count == 0)
+            if (interpreter.ExecStack.Count == 0)
                 return;
 
             var expandExpression = new ExecExpandExpression(new[]
             {
-                interpreterService.ExecStack.Top,
+                interpreter.ExecStack.Top,
                 new ExecYExpression()
             });
 
-            interpreterService.ExecStack.Insert(interpreterService.ExecStack.Count - 1, expandExpression);
+            interpreter.ExecStack.Insert(interpreter.ExecStack.Count - 1, expandExpression);
+        }
+
+        public override string ToString()
+        {
+            return Symbols.ExecY;
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Expression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Expression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Expression.cs	(revision 14328)
@@ -1,4 +1,5 @@
 ﻿using System;
 using System.Collections.Generic;
+using HeuristicLab.Algorithms.PushGP.Interpreter;
 using HeuristicLab.Algorithms.PushGP.Stack;
 
@@ -7,24 +8,13 @@
     public abstract class Expression
     {
-        public Expression(OpCode opCode)
-        {
-            this.OpCode = opCode;
-        }
+        public abstract bool IsCodeOp { get; }
+        public abstract void Eval(IInterpreter interpreter);
 
-        public OpCode OpCode { get; }
-
-        public abstract void Eval(IInterpreterService interpreterService);
-
-        public override string ToString()
-        {
-            return SymbolTable.GetSymbol(this.OpCode);
-        }
-
-        protected static void PushResult<T>(IStack<T> stack, int count, Func<T[], T> templateFunc)
+        public void PushResult<T>(IStack<T> stack, int count, Func<T[], T> templateFunc)
         {
             PushResult(stack, stack, count, templateFunc);
         }
 
-        protected static void PushResult<T, R>(IStack<T> sourceStack, IStack<R> targetStack, int count, Func<T[], R> templateFunc)
+        public void PushResult<T, R>(IStack<T> sourceStack, IStack<R> targetStack, int count, Func<T[], R> templateFunc)
         {
             // not enough arguments on stack
@@ -38,5 +28,5 @@
         }
 
-        protected static void Duplicate<T>(IStack<T> stack)
+        public void Duplicate<T>(IStack<T> stack)
         {
             // not enough arguments on stack
